package cz.fi.muni.pa165.dao;

import cz.fi.muni.pa165.entity.Activity;
import org.springframework.stereotype.Repository;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;

/**
 * @author Dávid Želník - 469323
 */
@Repository
public class ActivityDaoImpl implements ActivityDao{

    @PersistenceContext
    private EntityManager em;

    @Override
    public void create(Activity activity) {
        em.persist(activity);
    }

    @Override
    public Activity findById(Long id) {
        return em.find(Activity.class, id);
    }

    @Override
    public List<Activity> findByName(String name) {
        return em.createQuery("select a from Activity a where a.name = :name", Activity.class)
                .setParameter("name", name)
                .getResultList();
    }

    @Override
    public void update(Activity activity) {
        em.merge(activity);
    }

    @Override
    public void delete(Activity activity) {
        em.remove(findById(activity.getId()));
    }
}
