package cz.fi.muni.pa165.dao;

import cz.fi.muni.pa165.entity.Album;
import org.springframework.stereotype.Repository;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;

/**
 * @author David Sapák
 */
@Repository
public class AlbumDaoImpl implements AlbumDao{

    @PersistenceContext
    private EntityManager em;

    @Override
    public void create(Album album){ em.persist(album);}

    @Override
    public Album findById(Long id){ return em.find(Album.class, id);}

    @Override
    public List<Album> findByName(String name){
        return em.createQuery("Select a from Album a where a.name = :name", Album.class)
                .setParameter("name", name)
                .getResultList();
    }

    @Override
    public void update(Album album){ em.merge(album);}

    @Override
    public void delete(Album album){ em.remove(findById(album.getId()));}
}
