package cz.fi.muni.pa165.dao;

import cz.fi.muni.pa165.entity.Band;
import org.springframework.stereotype.Repository;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;

/**
 * @author Dávid Želník - 469323
 */
@Repository
public class BandDaoImpl implements BandDao{

    @PersistenceContext
    private EntityManager em;

    @Override
    public void create(Band band) {
        em.persist(band);
    }

    @Override
    public Band findById(Long id) {
        return em.find(Band.class, id);
    }

    @Override
    public List<Band> findByName(String name) {
         return em.createQuery("select b from Band b where b.name = :name", Band.class)
                .setParameter("name", name)
                .getResultList();
    }

    @Override
    public void update(Band band) {
        em.merge(band);
    }

    @Override
    public void delete(Band band) {
        em.remove(findById(band.getId()));
    }
}
