package cz.fi.muni.pa165.dao;

import cz.fi.muni.pa165.entity.Manager;
import org.springframework.stereotype.Repository;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;

/**
 * @author Pavel Vašina - 445606
 */
@Repository
public class ManagerDaoImpl implements ManagerDao {
    @PersistenceContext
    private EntityManager em;

    @Override
    public void create(Manager manager) {
        em.persist(manager);
    }

    @Override
    public Manager findById(Long id) {
        return em.find(Manager.class, id);
    }

    @Override
    public List<Manager> findByName(String name) {
        return em.createQuery("select m from Manager m where m.name = :name", Manager.class)
                .setParameter("name", name)
                .getResultList();
    }

    @Override
    public void update(Manager manager) {
        em.merge(manager);
    }

    @Override
    public void delete(Manager manager) {
        em.remove(findById(manager.getId()));
    }
}
