package cz.fi.muni.pa165.dao;

import cz.fi.muni.pa165.entity.Musician;
import org.springframework.stereotype.Repository;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;

/**
 * @author Zuzana Tunegová
 */
@Repository
public class MusicianDaoImpl implements MusicianDao{

    @PersistenceContext
    private EntityManager em;

    @Override
    public void create(Musician musician) {
        em.persist(musician);
    }

    @Override
    public Musician findById(Long id) {
        return em.find(Musician.class, id);
    }

    @Override
    public List<Musician> findByName(String name) {
        return em.createQuery("select m from Musician m where m.name = :name", Musician.class)
                .setParameter("name", name)
                .getResultList();
    }

    @Override
    public void update(Musician musician) {
        em.merge(musician);
    }

    @Override
    public void delete(Musician musician) {
        em.remove(findById(musician.getId()));
    }
}
