package cz.fi.muni.pa165.dao;

import cz.fi.muni.pa165.entity.Song;
import org.springframework.stereotype.Repository;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;

/**
 * @author David Sapák
 */
@Repository
public class SongDaoImpl implements SongDao{

    @PersistenceContext
    private EntityManager em;

    @Override
    public void create(Song song) {
        em.persist(song);
    }

    @Override
    public Song findById(Long id) {
        return em.find(Song.class, id);
    }

    @Override
    public List<Song> findByName(String name) {
        return em.createQuery("select s from Song s where s.songName = :name", Song.class)
                .setParameter("name", name)
                .getResultList();
    }

    @Override
    public void update(Song song) {
        em.merge(song);
    }

    @Override
    public void delete(Song song) {
        em.remove(findById(song.getId()));
    }
}
