package cz.fi.muni.pa165.entity;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Set;

/**
 * @author David Sapák
 */
@Entity
public class Album {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @NotNull
    @Column(nullable = false)
    private String name;

    @NotNull
    @ManyToOne @JoinColumn(name = "band_id")
    private Band band;

    @OneToMany @JoinColumn(name = "song_id")
    private Set<Song> songs;

    public Long getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    public Set<Song> getSongs() {
        return songs;
    }

    public Band getBand() {
        return band;
    }

    public void setBand(Band bandName) {
        this.band = bandName;
    }

    public void setSongs(Set<Song> songs) {
        this.songs = songs;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null)
            return false;
        if (!(o instanceof Album))
            return false;
        Album album = (Album) o;
        return getId().equals(album.getId()) && getName().equals(album.getName()) && (getSongs().stream().count() == album.getSongs().stream().count());
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (getName() != null ? getName().hashCode() : 0);
        result = prime * result + (getSongs() != null ? getSongs().hashCode() : 0);
        return result;
    }


    @Override
    public String toString() {
        return "Album{" +
                "id=" + id +
                ", name='" + name + '\'' +
                ", bandName='" + band.getName() + '\'' +
                ", songs=" + songs +
                '}';
    }
}
