package cz.fi.muni.pa165.entity;

import cz.fi.muni.pa165.enums.BandType;
import org.springframework.validation.annotation.Validated;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Set;

/**
 * @author Dávid Želník - 469323
 */
@Entity
@Validated
public class Band{

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @NotNull
    @Column(nullable = false)
    private String name;

    @NotNull
    @Column(nullable = false)
    @Enumerated(EnumType.STRING)
    private BandType type;

    @Column
    private String logo;

    @OneToMany
    private Set<Activity> activities;

    @OneToMany
    private Set<Song> bandSongs;

    @OneToMany
    private Set<Album> bandAlbums;

    @NotNull
    @Column(nullable = false)
    @OneToMany @JoinColumn(name= "musician_id")
    private Set<Musician> bandMembers;

    public Long getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public BandType getType() {
        return type;
    }

    public Set<Song> getBandSongs() {
        return bandSongs;
    }

    public String getLogo() {
        return logo;
    }

    public Set<Album> getBandAlbums() {
        return bandAlbums;
    }

    public Set<Musician> getBandMembers() {
        return bandMembers;
    }

    public Set<Activity> getActivities() {
        return activities;
    }

    public void setType(BandType type) {
        this.type = type;
    }

    public void setLogo(String logo) {
        this.logo = logo;
    }

    public void setActivities(Set<Activity> activities) {
        this.activities = activities;
    }

    public void setBandSongs(Set<Song> bandSongs) {
        this.bandSongs = bandSongs;
    }

    public void setBandAlbums(Set<Album> bandAlbums) {
        this.bandAlbums = bandAlbums;
    }

    public void setBandMembers(Set<Musician> bandMembers) {
        this.bandMembers = bandMembers;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o)
            return true;
        if (!(o instanceof Band))
            return false;
        Band band = (Band) o;
        return getId().equals(band.getId()) && getName().equals(band.getName()) && getType() == band.getType();
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (getName() != null ? getName().hashCode() : 0);
        result = prime * result + (getId() != null ? getId().hashCode() : 0);
        result = prime * result + (getType() != null ? getType().hashCode() : 0);
        return result;
    }

    @Override
    public String toString() {
        return "Band{" +
                "id=" + id +
                ", name='" + name + '\'' +
                ", type=" + type +
                ", logo='" + logo + '\'' +
                ", activities=" + activities +
                ", bandSongs=" + bandSongs +
                ", bandAlbums=" + bandAlbums +
                ", bandMembers=" + bandMembers +
                '}';
    }
}
