package cz.fi.muni.pa165.entity;

import org.springframework.validation.annotation.Validated;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Set;

/**
 * @author Pavel Vašina - 445606
 */
@Entity
@Validated
public class Manager {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @NotNull
    @Column(nullable = false)
    private String name;

    @OneToMany
    private Set<Band> managedBands;

    public Long getId() {
        return id;
    }

    public void setName(String name){
        this.name = name;
    }

    public String getName(){
        return name;
    }

    public void setManagedBands(Set<Band> managedBands){
        this.managedBands = managedBands;
    };

    public void addManagedBand(Band band){
        this.managedBands.add(band);
    }

    public Set<Band> getManagedBands(){
        return managedBands;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null)
            return false;
        if (!(o instanceof Manager))
            return false;
        Manager manager = (Manager) o;
        return getId().equals(manager.getId()) && getName().equals(manager.getName());
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((name == null) ? 0 : name.hashCode());
        result = prime * result + (getId() != null ? getId().hashCode() : 0);
        return result;
    }

    @Override
    public String toString() {
        return "Manager{" +
                "id=" + id +
                ", name='" + name + '\'' +
                ", managedBands=" + managedBands +
                '}';
    }
}
