package cz.fi.muni.pa165.entity;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.sql.Time;


/**
 * @author David Sapák
 */
@Entity
public class Song {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @NotNull
    @Column(nullable = false)
    private String songName;

    @NotNull
    @ManyToOne @JoinColumn(name = "band_id")
    private Band band;

    @NotNull
    @Column(nullable = false)
    private Time duration;

    @ManyToOne
    private Album album;

    public Long getId() {
        return id;
    }

    public String getSongName() {
        return songName;
    }

    public Band getBand() {
        return band;
    }

    public Time getDuration() {
        return duration;
    }

    public Album getAlbum() { return album; }

    public void setSongName(String songName) {
        this.songName = songName;
    }

    public void setBand(Band band) {
        this.band = band;
    }

    public void setDuration(Time duration) {
        this.duration = duration;
    }

    public void setAlbum(Album album) { this.album = album; }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null)
            return false;
        if (!(o instanceof Song))
            return false;
        Song song = (Song) o;
        return getId().equals(song.getId()) && getSongName().equals(song.getSongName()) && (getDuration().toString().equals(song.getDuration().toString()));
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (getSongName() != null ? getSongName().hashCode() : 0);
        result = prime * result + (getDuration() != null ? getDuration().hashCode() : 0);
        return result;
    }

    @Override
    public String toString() {
        return "Song{" +
                "id=" + id +
                ", songName='" + songName + '\'' +
                ", bandName='" + band.getName() + '\'' +
                ", album='" + album + '\'' +
                ", duration=" + duration +
                '}';
    }
}
